<script>
  export let login_data;

  import { fade } from 'svelte/transition'
  import { cc } from "./cc.js"
  import "../tachyons/css/tachyons.css"
  import Keypad from "./Keypad.svelte"
  /*
   * states:
   *   0   inputting item cost
   *   1   inputting item after period
   *   10  inputting tender
   *   11  inputting tender after period
   */
  let state = 0;
  let total = 0;
  let last = 0;
  let change = '-';
  let current = '0';
  function handleKey(ev) {
    const key = ev.detail.key;
    if (key == '.') {
      if (state == 0 || state == 10) {
        state += 1;
        current += key;
      }
      return;
    }
    // numeric
    const m = current.match(/\.(.*)/);
    if (m && m[1].length >= 2) {
      return;
    }
    if (key == '0') {
      if (current != '' && current != '0') {
        current += key;
      }
    } else if (0 < Number(key) && Number(key) < 10) {
      current = current == '0' ? key : current + key;
    }
  }
  function reset() {
    state = total = last = 0;
    current = '0';
    change = '-';
  }
  function handleCancel() {
    reset()
  }
  function handleAdd() {
    if (state >= 10) {
      return;
    }
    const n = Number(current);
    if (isNaN(n)) {
      return;
    }
    total += n;
    last = n;
    current = '0';
    change = '-'
    state -= state % 10;
  }
  function handleTender() {
    if (total == 0) {
      return;
    }
    const n = Number(current);
    if (isNaN(n)) {
      return;
    }
    last = '0'
    current = '0'
    const difference = total - n;
    total = Math.max(difference, 0)
    change = -Math.min(difference, 0)
    
  }
</script>

<style>
  button {
  width: 100%;
  }
</style>


<div transition:fade>
  <div class="h4 dark-green bg-light-gray pa2 br2">
    <div class="fl w-50">
      <div class="f3">
        Last: ${last}
      </div>
      <div class="f3">
        Total: ${total}
      </div>
      <div class="f3">
        Change: {change}
      </div>
    </div>
    <div class="fl w-50 f1">
      ${current}
    </div>
  </div>
  <div>
    <div class="fl w-25">
      <div class="pa1">
        <button class="br3 bg-light-green h3" on:click={handleAdd}>Add</button>
      </div>
      <div class="pa1">
        <button class="br3 bg-light-yellow" on:click={handleTender}>Tender</button>
      </div>
      <div class="pa1">
        <button class="br3 bg-light-red" on:click={handleCancel}>Cancel</button>
      </div>
    </div>
    <div class="fl w-25 pa1">
    </div>
    <div class="fl w-50 pa1">
      <Keypad on:key={handleKey}/>
    </div>
  </div>
</div>
